

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Time, Calendar and periods &mdash; Documentation</title>
  

  
  
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
  
  
  

  
  <script type="text/javascript" src="../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
        <script src="../../_static/jquery.js"></script>
        <script src="../../_static/underscore.js"></script>
        <script src="../../_static/doctools.js"></script>
        <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
        <script async="async" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.7/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
        <script type="text/x-mathjax-config">MathJax.Hub.Config({"tex2jax": {"inlineMath": [["$", "$"], ["\\(", "\\)"]], "processEscapes": true, "ignoreClass": "document", "processClass": "math|output_area"}})</script>
        <script src="../../_static/js/bootstrap.min.js"></script>
        <script src="../../_static/js/bootstrap.bundle.min.js"></script>
        <script src="../../_static/js/custom.js"></script>
    
    <script type="text/javascript" src="../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap-grid.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/custom.css" type="text/css" />
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../index.html" class="icon icon-home"> Shyft
          

          
          </a>

          
            
            
              <div class="version">
                4.12
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Project</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/what_is_shyft.html">What is Shyft?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/get_involved.html">Get involved</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/contact.html">Contact</a></li>
</ul>
<p class="caption"><span class="caption-text">Time Series</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Hydrology</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Energy Market</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Dashboard</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/api.html">API Documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">Shyft</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../index.html">Docs</a> &raquo;</li>
        
      <li>Time, Calendar and periods</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../_sources/notebooks/time_series/time_calendar_period.ipynb.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  
<style>
/* CSS for nbsphinx extension */

/* remove conflicting styling from Sphinx themes */
div.nbinput.container div.prompt *,
div.nboutput.container div.prompt *,
div.nbinput.container div.input_area pre,
div.nboutput.container div.output_area pre,
div.nbinput.container div.input_area .highlight,
div.nboutput.container div.output_area .highlight {
    border: none;
    padding: 0;
    margin: 0;
    box-shadow: none;
}

div.nbinput.container > div[class*=highlight],
div.nboutput.container > div[class*=highlight] {
    margin: 0;
}

div.nbinput.container div.prompt *,
div.nboutput.container div.prompt * {
    background: none;
}

div.nboutput.container div.output_area .highlight,
div.nboutput.container div.output_area pre {
    background: unset;
}

div.nboutput.container div.output_area div.highlight {
    color: unset;  /* override Pygments text color */
}

/* avoid gaps between output lines */
div.nboutput.container div[class*=highlight] pre {
    line-height: normal;
}

/* input/output containers */
div.nbinput.container,
div.nboutput.container {
    display: -webkit-flex;
    display: flex;
    align-items: flex-start;
    margin: 0;
    width: 100%;
}
@media (max-width: 540px) {
    div.nbinput.container,
    div.nboutput.container {
        flex-direction: column;
    }
}

/* input container */
div.nbinput.container {
    padding-top: 5px;
}

/* last container */
div.nblast.container {
    padding-bottom: 5px;
}

/* input prompt */
div.nbinput.container div.prompt pre {
    color: #307FC1;
}

/* output prompt */
div.nboutput.container div.prompt pre {
    color: #BF5B3D;
}

/* all prompts */
div.nbinput.container div.prompt,
div.nboutput.container div.prompt {
    width: 4.5ex;
    padding-top: 5px;
    position: relative;
    user-select: none;
}

div.nbinput.container div.prompt > div,
div.nboutput.container div.prompt > div {
    position: absolute;
    right: 0;
    margin-right: 0.3ex;
}

@media (max-width: 540px) {
    div.nbinput.container div.prompt,
    div.nboutput.container div.prompt {
        width: unset;
        text-align: left;
        padding: 0.4em;
    }
    div.nboutput.container div.prompt.empty {
        padding: 0;
    }

    div.nbinput.container div.prompt > div,
    div.nboutput.container div.prompt > div {
        position: unset;
    }
}

/* disable scrollbars on prompts */
div.nbinput.container div.prompt pre,
div.nboutput.container div.prompt pre {
    overflow: hidden;
}

/* input/output area */
div.nbinput.container div.input_area,
div.nboutput.container div.output_area {
    -webkit-flex: 1;
    flex: 1;
    overflow: auto;
}
@media (max-width: 540px) {
    div.nbinput.container div.input_area,
    div.nboutput.container div.output_area {
        width: 100%;
    }
}

/* input area */
div.nbinput.container div.input_area {
    border: 1px solid #e0e0e0;
    border-radius: 2px;
    /*background: #f5f5f5;*/
}

/* override MathJax center alignment in output cells */
div.nboutput.container div[class*=MathJax] {
    text-align: left !important;
}

/* override sphinx.ext.imgmath center alignment in output cells */
div.nboutput.container div.math p {
    text-align: left;
}

/* standard error */
div.nboutput.container div.output_area.stderr {
    background: #fdd;
}

/* ANSI colors */
.ansi-black-fg { color: #3E424D; }
.ansi-black-bg { background-color: #3E424D; }
.ansi-black-intense-fg { color: #282C36; }
.ansi-black-intense-bg { background-color: #282C36; }
.ansi-red-fg { color: #E75C58; }
.ansi-red-bg { background-color: #E75C58; }
.ansi-red-intense-fg { color: #B22B31; }
.ansi-red-intense-bg { background-color: #B22B31; }
.ansi-green-fg { color: #00A250; }
.ansi-green-bg { background-color: #00A250; }
.ansi-green-intense-fg { color: #007427; }
.ansi-green-intense-bg { background-color: #007427; }
.ansi-yellow-fg { color: #DDB62B; }
.ansi-yellow-bg { background-color: #DDB62B; }
.ansi-yellow-intense-fg { color: #B27D12; }
.ansi-yellow-intense-bg { background-color: #B27D12; }
.ansi-blue-fg { color: #208FFB; }
.ansi-blue-bg { background-color: #208FFB; }
.ansi-blue-intense-fg { color: #0065CA; }
.ansi-blue-intense-bg { background-color: #0065CA; }
.ansi-magenta-fg { color: #D160C4; }
.ansi-magenta-bg { background-color: #D160C4; }
.ansi-magenta-intense-fg { color: #A03196; }
.ansi-magenta-intense-bg { background-color: #A03196; }
.ansi-cyan-fg { color: #60C6C8; }
.ansi-cyan-bg { background-color: #60C6C8; }
.ansi-cyan-intense-fg { color: #258F8F; }
.ansi-cyan-intense-bg { background-color: #258F8F; }
.ansi-white-fg { color: #C5C1B4; }
.ansi-white-bg { background-color: #C5C1B4; }
.ansi-white-intense-fg { color: #A1A6B2; }
.ansi-white-intense-bg { background-color: #A1A6B2; }

.ansi-default-inverse-fg { color: #FFFFFF; }
.ansi-default-inverse-bg { background-color: #000000; }

.ansi-bold { font-weight: bold; }
.ansi-underline { text-decoration: underline; }


div.nbinput.container div.input_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight].math,
div.nboutput.container div.output_area.rendered_html,
div.nboutput.container div.output_area > div.output_javascript,
div.nboutput.container div.output_area:not(.rendered_html) > img{
    padding: 5px;
    margin: 0;
}

/* fix copybtn overflow problem in chromium (needed for 'sphinx_copybutton') */
div.nbinput.container div.input_area > div[class^='highlight'],
div.nboutput.container div.output_area > div[class^='highlight']{
    overflow-y: hidden;
}

/* hide copybtn icon on prompts (needed for 'sphinx_copybutton') */
.prompt a.copybtn {
    display: none;
}

/* Some additional styling taken form the Jupyter notebook CSS */
div.rendered_html table {
  border: none;
  border-collapse: collapse;
  border-spacing: 0;
  color: black;
  font-size: 12px;
  table-layout: fixed;
}
div.rendered_html thead {
  border-bottom: 1px solid black;
  vertical-align: bottom;
}
div.rendered_html tr,
div.rendered_html th,
div.rendered_html td {
  text-align: right;
  vertical-align: middle;
  padding: 0.5em 0.5em;
  line-height: normal;
  white-space: normal;
  max-width: none;
  border: none;
}
div.rendered_html th {
  font-weight: bold;
}
div.rendered_html tbody tr:nth-child(odd) {
  background: #f5f5f5;
}
div.rendered_html tbody tr:hover {
  background: rgba(66, 165, 245, 0.2);
}

/* CSS overrides for sphinx_rtd_theme */

/* 24px margin */
.nbinput.nblast.container,
.nboutput.nblast.container {
    margin-bottom: 19px;  /* padding has already 5px */
}

/* ... except between code cells! */
.nblast.container + .nbinput.container {
    margin-top: -19px;
}

.admonition > p:before {
    margin-right: 4px;  /* make room for the exclamation icon */
}

/* Fix math alignment, see https://github.com/rtfd/sphinx_rtd_theme/pull/686 */
.math {
    text-align: unset;
}
</style>
<div class="section" id="Time,-Calendar-and-periods">
<h1>Time, Calendar and periods<a class="headerlink" href="#Time,-Calendar-and-periods" title="Permalink to this headline">¶</a></h1>
<p>This section is a dive into three of the time constructs available from SHyFT: the time type, the calendar, and the time period. ̨ It is necessary to understand the underlying time representation, and how to manipulate it, to be able to both display and work with time series data correctly, and to set up and perfom computations.</p>
<hr class="docutils" />
<p><strong>Contents:</strong></p>
<ul>
<li><p><a class="reference external" href="#SHyFT-time">SHyFT time</a></p></li>
<li><p><a class="reference external" href="#Calendars">Calendars</a></p>
<ul class="simple">
<li><p><a class="reference external" href="#Initializing-calendars">Initializing calendars</a></p></li>
<li><p><a class="reference external" href="#Construct-localized-time">Construct localized time</a></p></li>
<li><p><a class="reference external" href="#Stringifying-local-time">Stringifying local time</a></p></li>
<li><p><a class="reference external" href="#Trim-time">Trim time</a></p></li>
<li><p><a class="reference external" href="#Add-to-time">Add to time</a></p></li>
<li><p><a class="reference external" href="#Diff-moments">Diff moments</a></p></li>
<li><p><a class="reference external" href="#Time-constants">Time constants</a></p></li>
</ul>
</li>
<li><p><a class="reference external" href="#Time-periods">Time periods (UtcPeriod)</a></p>
<ul>
<li><p><a class="reference external" href="#Initialization">Initialization</a></p></li>
<li><p><a class="reference external" href="#List-of-functions">List of functions</a></p></li>
<li><p><a class="reference external" href="#Start-&amp;-end">Start &amp; end</a></p></li>
<li><p><a class="reference external" href="#Timespan">Timespan</a></p></li>
<li><p><a class="reference external" href="#Valid">Valid</a></p></li>
<li><p><a class="reference external" href="#To-string">To string</a></p></li>
<li><p><a class="reference external" href="#Trimming-periods">Trimming periods</a></p></li>
<li><p><a class="reference external" href="#Intersection-&amp;-overlap">Intersection &amp; overlap</a></p></li>
<li><p><a class="reference external" href="#Moment-in-period">Moment in period</a></p></li>
<li><p class="rubric" id="diff-a-period"><a class="reference external" href="#Diff-a-period">Diff a period</a></p>
</li>
</ul>
</li>
</ul>
<p>To start of we need to import the time series library of SHyFT, we put it into an alias <code class="docutils literal notranslate"><span class="pre">sts</span></code>.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[1]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">shyft.time_series</span> <span class="k">as</span> <span class="nn">sts</span>
</pre></div>
</div>
</div>
<div class="section" id="SHyFT-time">
<h2>SHyFT time<a class="headerlink" href="#SHyFT-time" title="Permalink to this headline">¶</a></h2>
<p>SHyFT considers time as UTC+0 internally, is is stored and used as a number in the SHyFT core and it can represent time at the microsecond resolution.</p>
<p>In the Python API time is exposed through the <code class="docutils literal notranslate"><span class="pre">time</span></code> class. Objects of this class is not that interesting, their main purpose is so the C++ implementation of SHyFT can speak with the Python API correctly. In addition to this this class helps with parsing and stringifying UTC+0 time as well.</p>
<p>When using the <code class="docutils literal notranslate"><span class="pre">time</span></code> class is that values or objects of this class can both represent a concrete date/time, or a delta or offset without any particular meaning as a point in time. It is simply a value able to be interpreted in multiple ways.</p>
<p>We will mostly ignore the sub-second resolution of time.</p>
<hr class="docutils" />
<p>The first way to initialize a time value is by passing it a number of seconds since the epoch. The epoch is the origin of the time system, SHyFT uses the regular epoch: 1970-01-01T00:00:00.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[2]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">time_point</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">1559563200</span><span class="p">)</span>
<span class="n">time_point</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[2]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
time(1559563200)
</pre></div></div>
</div>
<p>We can stringify the time value we just made. This will give us a time string following ISO8601:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[3]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="nb">str</span><span class="p">(</span><span class="n">time_point</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[3]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&#39;2019-06-03T12:00:00Z&#39;
</pre></div></div>
</div>
<p>We can also pass the ISO8601 string back to the time class to construct a moment as specified in the string.</p>
<p><strong>Note</strong> that SHyFT only parses a subset of ISO8601 so many perfectly valid time strings produces errors, and it does not even parse every time string it produces itself.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[4]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">sts</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="s1">&#39;2019-06-03T12:00:00.000000Z&#39;</span><span class="p">)</span>  <span class="c1"># mostly iso8601 time strings</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[4]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
time(1559563200)
</pre></div></div>
</div>
<p>An example of a ISO8601 that does not work is if we add the UTC-offset</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[5]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="k">try</span><span class="p">:</span>
    <span class="n">sts</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="s1">&#39;2019-06-03T11:00:00.000000+01&#39;</span><span class="p">)</span>
<span class="k">except</span> <span class="ne">RuntimeError</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
    <span class="nb">print</span><span class="p">(</span><span class="n">e</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Needs format &#39;YYYY-MM-DDThh:mm:ssZ&#39;: got 2019-06-03T11:00:00.000000+01
</pre></div></div>
</div>
<p>Since time is a simple number we can work with it using simple arithmetics. We can add or subtract to it using <code class="docutils literal notranslate"><span class="pre">+</span></code> and <code class="docutils literal notranslate"><span class="pre">-</span></code>, multiply and divide it using <code class="docutils literal notranslate"><span class="pre">*</span></code> and <code class="docutils literal notranslate"><span class="pre">/</span></code>.</p>
<p>When doing arithmetics with time we can use regular numbers, the result will be a <code class="docutils literal notranslate"><span class="pre">time</span></code> object if at least one <code class="docutils literal notranslate"><span class="pre">time</span></code> object is involved in the computation. Numbers will be interpreted as seconds, while any fractional parts of the numbers will be interpreted as sub-seconds down to microseconds.</p>
<p>The next cell add one hour, 3600 seconds, to the time point we defined in the start of this section:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[6]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="nb">str</span><span class="p">(</span><span class="n">time_point</span> <span class="o">+</span> <span class="mi">3600</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[6]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&#39;2019-06-03T13:00:00Z&#39;
</pre></div></div>
</div>
<p>To get the current time we can use <code class="docutils literal notranslate"><span class="pre">utctime_now()</span></code> that we imported earlier. This function returns a time point representing the time at which the function was called:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[7]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="nb">str</span><span class="p">(</span><span class="n">sts</span><span class="o">.</span><span class="n">utctime_now</span><span class="p">())</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[7]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&#39;2021-03-15T13:19:49.211212Z&#39;
</pre></div></div>
</div>
<p>The three time constants we imported represent respectivly the least and largest time representable, and invalid time.</p>
<p>The minimum and maximum time constructs are mostly usefull as default values, and for creating time periods spanning “all” of time.</p>
<p>Invalid time may be returned by some functions to represent that whatever operation it were to do did not work, and some SHyFT constructs initialize to it by default.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[8]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">sts</span><span class="o">.</span><span class="n">min_utctime</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[8]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
time(-9223372036854.775391)
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[9]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">sts</span><span class="o">.</span><span class="n">max_utctime</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[9]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
time(9223372036854.775391)
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[10]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">sts</span><span class="o">.</span><span class="n">no_utctime</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[10]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
time(-9223372036854.775391)
</pre></div></div>
</div>
</div>
<hr class="docutils" />
<div class="section" id="Calendars">
<h2>Calendars<a class="headerlink" href="#Calendars" title="Permalink to this headline">¶</a></h2>
<p>Since SHyFT represent time solely as UTC+0 we need some construct that is able to work with localized time. This is the purpose of the calendar construct.</p>
<div class="section" id="Initializing-calendars">
<h3>Initializing calendars<a class="headerlink" href="#Initializing-calendars" title="Permalink to this headline">¶</a></h3>
<p>To construct a SHyFT calendar we need to provide the time zone specification it should use. If we do not specify any time zone it defaults to UTC+0.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[11]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">utc</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">Calendar</span><span class="p">()</span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[12]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">utc_p5</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">Calendar</span><span class="p">(</span><span class="s1">&#39;UTC+5&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[13]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">utc_m2</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">Calendar</span><span class="p">(</span><span class="s1">&#39;UTC-2&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[14]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">oslo</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">Calendar</span><span class="p">(</span><span class="s1">&#39;Europe/Oslo&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<p>We can list all the available specification by calling the function <code class="docutils literal notranslate"><span class="pre">region_id_list</span></code> on the calendar:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[15]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="nb">list</span><span class="p">(</span><span class="n">sts</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">region_id_list</span><span class="p">())</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[15]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
[&#39;Africa/Abidjan&#39;,
 &#39;Africa/Accra&#39;,
 &#39;Africa/Addis_Ababa&#39;,
 &#39;Africa/Algiers&#39;,
 &#39;Africa/Asmera&#39;,
 &#39;Africa/Bamako&#39;,
 &#39;Africa/Bangui&#39;,
 &#39;Africa/Banjul&#39;,
 &#39;Africa/Bissau&#39;,
 &#39;Africa/Blantyre&#39;,
 &#39;Africa/Brazzaville&#39;,
 &#39;Africa/Bujumbura&#39;,
 &#39;Africa/Cairo&#39;,
 &#39;Africa/Casablanca&#39;,
 &#39;Africa/Ceuta&#39;,
 &#39;Africa/Conakry&#39;,
 &#39;Africa/Dakar&#39;,
 &#39;Africa/Dar_es_Salaam&#39;,
 &#39;Africa/Djibouti&#39;,
 &#39;Africa/Douala&#39;,
 &#39;Africa/El_Aaiun&#39;,
 &#39;Africa/Freetown&#39;,
 &#39;Africa/Gaborone&#39;,
 &#39;Africa/Harare&#39;,
 &#39;Africa/Johannesburg&#39;,
 &#39;Africa/Kampala&#39;,
 &#39;Africa/Khartoum&#39;,
 &#39;Africa/Kigali&#39;,
 &#39;Africa/Kinshasa&#39;,
 &#39;Africa/Lagos&#39;,
 &#39;Africa/Libreville&#39;,
 &#39;Africa/Lome&#39;,
 &#39;Africa/Luanda&#39;,
 &#39;Africa/Lubumbashi&#39;,
 &#39;Africa/Lusaka&#39;,
 &#39;Africa/Malabo&#39;,
 &#39;Africa/Maputo&#39;,
 &#39;Africa/Maseru&#39;,
 &#39;Africa/Mbabane&#39;,
 &#39;Africa/Mogadishu&#39;,
 &#39;Africa/Monrovia&#39;,
 &#39;Africa/Nairobi&#39;,
 &#39;Africa/Ndjamena&#39;,
 &#39;Africa/Niamey&#39;,
 &#39;Africa/Nouakchott&#39;,
 &#39;Africa/Ouagadougou&#39;,
 &#39;Africa/Porto-Novo&#39;,
 &#39;Africa/Sao_Tome&#39;,
 &#39;Africa/Timbuktu&#39;,
 &#39;Africa/Tripoli&#39;,
 &#39;Africa/Tunis&#39;,
 &#39;Africa/Windhoek&#39;,
 &#39;America/Adak&#39;,
 &#39;America/Anchorage&#39;,
 &#39;America/Anguilla&#39;,
 &#39;America/Antigua&#39;,
 &#39;America/Araguaina&#39;,
 &#39;America/Aruba&#39;,
 &#39;America/Asuncion&#39;,
 &#39;America/Barbados&#39;,
 &#39;America/Belem&#39;,
 &#39;America/Belize&#39;,
 &#39;America/Boa_Vista&#39;,
 &#39;America/Bogota&#39;,
 &#39;America/Boise&#39;,
 &#39;America/Buenos_Aires&#39;,
 &#39;America/Cambridge_Bay&#39;,
 &#39;America/Cancun&#39;,
 &#39;America/Caracas&#39;,
 &#39;America/Catamarca&#39;,
 &#39;America/Cayenne&#39;,
 &#39;America/Cayman&#39;,
 &#39;America/Chicago&#39;,
 &#39;America/Chihuahua&#39;,
 &#39;America/Cordoba&#39;,
 &#39;America/Costa_Rica&#39;,
 &#39;America/Cuiaba&#39;,
 &#39;America/Curacao&#39;,
 &#39;America/Danmarkshavn&#39;,
 &#39;America/Dawson&#39;,
 &#39;America/Dawson_Creek&#39;,
 &#39;America/Denver&#39;,
 &#39;America/Detroit&#39;,
 &#39;America/Dominica&#39;,
 &#39;America/Edmonton&#39;,
 &#39;America/Eirunepe&#39;,
 &#39;America/El_Salvador&#39;,
 &#39;America/Fortaleza&#39;,
 &#39;America/Glace_Bay&#39;,
 &#39;America/Godthab&#39;,
 &#39;America/Goose_Bay&#39;,
 &#39;America/Grand_Turk&#39;,
 &#39;America/Grenada&#39;,
 &#39;America/Guadeloupe&#39;,
 &#39;America/Guatemala&#39;,
 &#39;America/Guayaquil&#39;,
 &#39;America/Guyana&#39;,
 &#39;America/Halifax&#39;,
 &#39;America/Havana&#39;,
 &#39;America/Hermosillo&#39;,
 &#39;America/Indiana/Indianapolis&#39;,
 &#39;America/Indiana/Knox&#39;,
 &#39;America/Indiana/Marengo&#39;,
 &#39;America/Indiana/Vevay&#39;,
 &#39;America/Indianapolis&#39;,
 &#39;America/Inuvik&#39;,
 &#39;America/Iqaluit&#39;,
 &#39;America/Jamaica&#39;,
 &#39;America/Jujuy&#39;,
 &#39;America/Juneau&#39;,
 &#39;America/Kentucky/Louisville&#39;,
 &#39;America/Kentucky/Monticello&#39;,
 &#39;America/La_Paz&#39;,
 &#39;America/Lima&#39;,
 &#39;America/Los_Angeles&#39;,
 &#39;America/Louisville&#39;,
 &#39;America/Maceio&#39;,
 &#39;America/Managua&#39;,
 &#39;America/Manaus&#39;,
 &#39;America/Martinique&#39;,
 &#39;America/Mazatlan&#39;,
 &#39;America/Mendoza&#39;,
 &#39;America/Menominee&#39;,
 &#39;America/Merida&#39;,
 &#39;America/Mexico_City&#39;,
 &#39;America/Miquelon&#39;,
 &#39;America/Monterrey&#39;,
 &#39;America/Montevideo&#39;,
 &#39;America/Montreal&#39;,
 &#39;America/Montserrat&#39;,
 &#39;America/Nassau&#39;,
 &#39;America/New_York&#39;,
 &#39;America/Nipigon&#39;,
 &#39;America/Nome&#39;,
 &#39;America/Noronha&#39;,
 &#39;America/North_Dakota/Center&#39;,
 &#39;America/Panama&#39;,
 &#39;America/Pangnirtung&#39;,
 &#39;America/Paramaribo&#39;,
 &#39;America/Phoenix&#39;,
 &#39;America/Port-au-Prince&#39;,
 &#39;America/Port_of_Spain&#39;,
 &#39;America/Porto_Velho&#39;,
 &#39;America/Puerto_Rico&#39;,
 &#39;America/Rainy_River&#39;,
 &#39;America/Rankin_Inlet&#39;,
 &#39;America/Recife&#39;,
 &#39;America/Regina&#39;,
 &#39;America/Rio_Branco&#39;,
 &#39;America/Rosario&#39;,
 &#39;America/Santiago&#39;,
 &#39;America/Santo_Domingo&#39;,
 &#39;America/Sao_Paulo&#39;,
 &#39;America/Scoresbysund&#39;,
 &#39;America/Shiprock&#39;,
 &#39;America/St_Johns&#39;,
 &#39;America/St_Kitts&#39;,
 &#39;America/St_Lucia&#39;,
 &#39;America/St_Thomas&#39;,
 &#39;America/St_Vincent&#39;,
 &#39;America/Swift_Current&#39;,
 &#39;America/Tegucigalpa&#39;,
 &#39;America/Thule&#39;,
 &#39;America/Thunder_Bay&#39;,
 &#39;America/Tijuana&#39;,
 &#39;America/Tortola&#39;,
 &#39;America/Vancouver&#39;,
 &#39;America/Whitehorse&#39;,
 &#39;America/Winnipeg&#39;,
 &#39;America/Yakutat&#39;,
 &#39;America/Yellowknife&#39;,
 &#39;Antarctica/Casey&#39;,
 &#39;Antarctica/Davis&#39;,
 &#39;Antarctica/DumontDUrville&#39;,
 &#39;Antarctica/Mawson&#39;,
 &#39;Antarctica/McMurdo&#39;,
 &#39;Antarctica/Palmer&#39;,
 &#39;Antarctica/South_Pole&#39;,
 &#39;Antarctica/Syowa&#39;,
 &#39;Antarctica/Vostok&#39;,
 &#39;Arctic/Longyearbyen&#39;,
 &#39;Asia/Aden&#39;,
 &#39;Asia/Almaty&#39;,
 &#39;Asia/Amman&#39;,
 &#39;Asia/Anadyr&#39;,
 &#39;Asia/Aqtau&#39;,
 &#39;Asia/Aqtobe&#39;,
 &#39;Asia/Ashgabat&#39;,
 &#39;Asia/Baghdad&#39;,
 &#39;Asia/Bahrain&#39;,
 &#39;Asia/Baku&#39;,
 &#39;Asia/Bangkok&#39;,
 &#39;Asia/Beirut&#39;,
 &#39;Asia/Bishkek&#39;,
 &#39;Asia/Brunei&#39;,
 &#39;Asia/Calcutta&#39;,
 &#39;Asia/Choibalsan&#39;,
 &#39;Asia/Chongqing&#39;,
 &#39;Asia/Colombo&#39;,
 &#39;Asia/Damascus&#39;,
 &#39;Asia/Dhaka&#39;,
 &#39;Asia/Dili&#39;,
 &#39;Asia/Dubai&#39;,
 &#39;Asia/Dushanbe&#39;,
 &#39;Asia/Gaza&#39;,
 &#39;Asia/Harbin&#39;,
 &#39;Asia/Hong_Kong&#39;,
 &#39;Asia/Hovd&#39;,
 &#39;Asia/Irkutsk&#39;,
 &#39;Asia/Istanbul&#39;,
 &#39;Asia/Jakarta&#39;,
 &#39;Asia/Jayapura&#39;,
 &#39;Asia/Jerusalem&#39;,
 &#39;Asia/Kabul&#39;,
 &#39;Asia/Kamchatka&#39;,
 &#39;Asia/Karachi&#39;,
 &#39;Asia/Kashgar&#39;,
 &#39;Asia/Katmandu&#39;,
 &#39;Asia/Krasnoyarsk&#39;,
 &#39;Asia/Kuala_Lumpur&#39;,
 &#39;Asia/Kuching&#39;,
 &#39;Asia/Kuwait&#39;,
 &#39;Asia/Macao&#39;,
 &#39;Asia/Macau&#39;,
 &#39;Asia/Magadan&#39;,
 &#39;Asia/Makassar&#39;,
 &#39;Asia/Manila&#39;,
 &#39;Asia/Muscat&#39;,
 &#39;Asia/Nicosia&#39;,
 &#39;Asia/Novosibirsk&#39;,
 &#39;Asia/Omsk&#39;,
 &#39;Asia/Oral&#39;,
 &#39;Asia/Phnom_Penh&#39;,
 &#39;Asia/Pontianak&#39;,
 &#39;Asia/Pyongyang&#39;,
 &#39;Asia/Qatar&#39;,
 &#39;Asia/Qyzylorda&#39;,
 &#39;Asia/Rangoon&#39;,
 &#39;Asia/Riyadh&#39;,
 &#39;Asia/Saigon&#39;,
 &#39;Asia/Sakhalin&#39;,
 &#39;Asia/Samarkand&#39;,
 &#39;Asia/Seoul&#39;,
 &#39;Asia/Shanghai&#39;,
 &#39;Asia/Singapore&#39;,
 &#39;Asia/Taipei&#39;,
 &#39;Asia/Tashkent&#39;,
 &#39;Asia/Tbilisi&#39;,
 &#39;Asia/Tehran&#39;,
 &#39;Asia/Thimphu&#39;,
 &#39;Asia/Tokyo&#39;,
 &#39;Asia/Ujung_Pandang&#39;,
 &#39;Asia/Ulaanbaatar&#39;,
 &#39;Asia/Urumqi&#39;,
 &#39;Asia/Vientiane&#39;,
 &#39;Asia/Vladivostok&#39;,
 &#39;Asia/Yakutsk&#39;,
 &#39;Asia/Yekaterinburg&#39;,
 &#39;Asia/Yerevan&#39;,
 &#39;Atlantic/Azores&#39;,
 &#39;Atlantic/Bermuda&#39;,
 &#39;Atlantic/Canary&#39;,
 &#39;Atlantic/Cape_Verde&#39;,
 &#39;Atlantic/Faeroe&#39;,
 &#39;Atlantic/Jan_Mayen&#39;,
 &#39;Atlantic/Madeira&#39;,
 &#39;Atlantic/Reykjavik&#39;,
 &#39;Atlantic/South_Georgia&#39;,
 &#39;Atlantic/St_Helena&#39;,
 &#39;Atlantic/Stanley&#39;,
 &#39;Australia/Adelaide&#39;,
 &#39;Australia/Brisbane&#39;,
 &#39;Australia/Broken_Hill&#39;,
 &#39;Australia/Darwin&#39;,
 &#39;Australia/Eucla&#39;,
 &#39;Australia/Hobart&#39;,
 &#39;Australia/Lindeman&#39;,
 &#39;Australia/Lord_Howe&#39;,
 &#39;Australia/Melbourne&#39;,
 &#39;Australia/Perth&#39;,
 &#39;Australia/Sydney&#39;,
 &#39;Europe/Amsterdam&#39;,
 &#39;Europe/Andorra&#39;,
 &#39;Europe/Athens&#39;,
 &#39;Europe/Belfast&#39;,
 &#39;Europe/Belgrade&#39;,
 &#39;Europe/Berlin&#39;,
 &#39;Europe/Bratislava&#39;,
 &#39;Europe/Brussels&#39;,
 &#39;Europe/Bucharest&#39;,
 &#39;Europe/Budapest&#39;,
 &#39;Europe/Chisinau&#39;,
 &#39;Europe/Copenhagen&#39;,
 &#39;Europe/Dublin&#39;,
 &#39;Europe/Gibraltar&#39;,
 &#39;Europe/Helsinki&#39;,
 &#39;Europe/Istanbul&#39;,
 &#39;Europe/Kaliningrad&#39;,
 &#39;Europe/Kiev&#39;,
 &#39;Europe/Lisbon&#39;,
 &#39;Europe/Ljubljana&#39;,
 &#39;Europe/London&#39;,
 &#39;Europe/Luxembourg&#39;,
 &#39;Europe/Madrid&#39;,
 &#39;Europe/Malta&#39;,
 &#39;Europe/Minsk&#39;,
 &#39;Europe/Monaco&#39;,
 &#39;Europe/Moscow&#39;,
 &#39;Europe/Nicosia&#39;,
 &#39;Europe/Oslo&#39;,
 &#39;Europe/Paris&#39;,
 &#39;Europe/Prague&#39;,
 &#39;Europe/Riga&#39;,
 &#39;Europe/Rome&#39;,
 &#39;Europe/Samara&#39;,
 &#39;Europe/San_Marino&#39;,
 &#39;Europe/Sarajevo&#39;,
 &#39;Europe/Simferopol&#39;,
 &#39;Europe/Skopje&#39;,
 &#39;Europe/Sofia&#39;,
 &#39;Europe/Stockholm&#39;,
 &#39;Europe/Tallinn&#39;,
 &#39;Europe/Tirane&#39;,
 &#39;Europe/Uzhgorod&#39;,
 &#39;Europe/Vaduz&#39;,
 &#39;Europe/Vatican&#39;,
 &#39;Europe/Vienna&#39;,
 &#39;Europe/Vilnius&#39;,
 &#39;Europe/Warsaw&#39;,
 &#39;Europe/Zagreb&#39;,
 &#39;Europe/Zaporozhye&#39;,
 &#39;Europe/Zurich&#39;,
 &#39;Indian/Antananarivo&#39;,
 &#39;Indian/Chagos&#39;,
 &#39;Indian/Christmas&#39;,
 &#39;Indian/Cocos&#39;,
 &#39;Indian/Comoro&#39;,
 &#39;Indian/Kerguelen&#39;,
 &#39;Indian/Mahe&#39;,
 &#39;Indian/Maldives&#39;,
 &#39;Indian/Mauritius&#39;,
 &#39;Indian/Mayotte&#39;,
 &#39;Indian/Reunion&#39;,
 &#39;Pacific/Apia&#39;,
 &#39;Pacific/Auckland&#39;,
 &#39;Pacific/Chatham&#39;,
 &#39;Pacific/Easter&#39;,
 &#39;Pacific/Efate&#39;,
 &#39;Pacific/Enderbury&#39;,
 &#39;Pacific/Fakaofo&#39;,
 &#39;Pacific/Fiji&#39;,
 &#39;Pacific/Funafuti&#39;,
 &#39;Pacific/Galapagos&#39;,
 &#39;Pacific/Gambier&#39;,
 &#39;Pacific/Guadalcanal&#39;,
 &#39;Pacific/Guam&#39;,
 &#39;Pacific/Honolulu&#39;,
 &#39;Pacific/Johnston&#39;,
 &#39;Pacific/Kiritimati&#39;,
 &#39;Pacific/Kosrae&#39;,
 &#39;Pacific/Kwajalein&#39;,
 &#39;Pacific/Majuro&#39;,
 &#39;Pacific/Marquesas&#39;,
 &#39;Pacific/Midway&#39;,
 &#39;Pacific/Nauru&#39;,
 &#39;Pacific/Niue&#39;,
 &#39;Pacific/Norfolk&#39;,
 &#39;Pacific/Noumea&#39;,
 &#39;Pacific/Pago_Pago&#39;,
 &#39;Pacific/Palau&#39;,
 &#39;Pacific/Pitcairn&#39;,
 &#39;Pacific/Ponape&#39;,
 &#39;Pacific/Port_Moresby&#39;,
 &#39;Pacific/Rarotonga&#39;,
 &#39;Pacific/Saipan&#39;,
 &#39;Pacific/Tahiti&#39;,
 &#39;Pacific/Tarawa&#39;,
 &#39;Pacific/Tongatapu&#39;,
 &#39;Pacific/Truk&#39;,
 &#39;Pacific/Wake&#39;,
 &#39;Pacific/Wallis&#39;,
 &#39;Pacific/Yap&#39;,
 &#39;UTC&#39;,
 &#39;UTC+1&#39;,
 &#39;UTC+2&#39;,
 &#39;UTC+3&#39;,
 &#39;UTC+4&#39;,
 &#39;UTC+5&#39;,
 &#39;UTC+6&#39;,
 &#39;UTC+7&#39;,
 &#39;UTC+8&#39;,
 &#39;UTC+9&#39;,
 &#39;UTC+10&#39;,
 &#39;UTC+11&#39;,
 &#39;UTC+12&#39;,
 &#39;UTC-1&#39;,
 &#39;UTC-2&#39;,
 &#39;UTC-3&#39;,
 &#39;UTC-4&#39;,
 &#39;UTC-5&#39;,
 &#39;UTC-6&#39;,
 &#39;UTC-7&#39;,
 &#39;UTC-8&#39;,
 &#39;UTC-9&#39;,
 &#39;UTC-10&#39;,
 &#39;UTC-11&#39;,
 &#39;UTC-12&#39;,
 &#39;Etc/GMT&#39;,
 &#39;Etc/UTC&#39;,
 &#39;Etc/GMT+0&#39;,
 &#39;Etc/GMT+1&#39;,
 &#39;Etc/GMT+2&#39;,
 &#39;Etc/GMT+3&#39;,
 &#39;Etc/GMT+4&#39;,
 &#39;Etc/GMT+5&#39;,
 &#39;Etc/GMT+6&#39;,
 &#39;Etc/GMT+7&#39;,
 &#39;Etc/GMT+8&#39;,
 &#39;Etc/GMT+9&#39;,
 &#39;Etc/GMT+10&#39;,
 &#39;Etc/GMT+11&#39;,
 &#39;Etc/GMT+12&#39;,
 &#39;Etc/GMT-0&#39;,
 &#39;Etc/GMT-1&#39;,
 &#39;Etc/GMT-2&#39;,
 &#39;Etc/GMT-3&#39;,
 &#39;Etc/GMT-4&#39;,
 &#39;Etc/GMT-5&#39;,
 &#39;Etc/GMT-6&#39;,
 &#39;Etc/GMT-7&#39;,
 &#39;Etc/GMT-8&#39;,
 &#39;Etc/GMT-9&#39;,
 &#39;Etc/GMT-10&#39;,
 &#39;Etc/GMT-11&#39;,
 &#39;Etc/GMT-12&#39;,
 &#39;Etc/GMT-13&#39;,
 &#39;Etc/GMT-14&#39;]
</pre></div></div>
</div>
</div>
<div class="section" id="Construct-localized-time">
<h3>Construct localized time<a class="headerlink" href="#Construct-localized-time" title="Permalink to this headline">¶</a></h3>
<p>Calendars can construct time points by using the <code class="docutils literal notranslate"><span class="pre">time</span></code> function on them. This function can not accept ISO8601 string, it instead accepts numbers specifying the time point.</p>
<p>The only required argument is the year, but it can accept as many as seven values, in order: year, month, day, hour, minute, second, microsecond. As long as we specify the year, we can specify as few or many of the other, but we always have to specify all values in the order listed.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[16]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2019</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[16]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
time(1546300800)
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[17]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2019</span><span class="p">,</span> <span class="mi">5</span><span class="p">,</span> <span class="mi">31</span><span class="p">,</span> <span class="mi">13</span><span class="p">,</span> <span class="mi">52</span><span class="p">,</span> <span class="mi">30</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[17]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
time(1559310750)
</pre></div></div>
</div>
<p>To demonstrate that calendars produce localized time, take a look at the two following cells. Notice that the same time on the same day is specified, but the results are not equal:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[18]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2019</span><span class="p">,</span> <span class="mi">5</span><span class="p">,</span> <span class="mi">29</span><span class="p">,</span> <span class="mi">12</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[18]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
time(1559131200)
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[19]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">oslo</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2019</span><span class="p">,</span> <span class="mi">5</span><span class="p">,</span> <span class="mi">29</span><span class="p">,</span> <span class="mi">12</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[19]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
time(1559124000)
</pre></div></div>
</div>
</div>
<div class="section" id="Stringifying-local-time">
<h3>Stringifying local time<a class="headerlink" href="#Stringifying-local-time" title="Permalink to this headline">¶</a></h3>
<p>Calendars have a <code class="docutils literal notranslate"><span class="pre">to_string</span></code> function, this function produces ISO8601 strings with offset like the calendar.</p>
<p><strong>Note</strong> that SHyFT (at the time of writing) cannot parse these strings again, as it only parses ISO8601 string where both the hour and minute of the offset is specified, but it writes strings with only the hour.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[20]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># stringify now using the local calendar</span>
<span class="n">oslo</span><span class="o">.</span><span class="n">to_string</span><span class="p">(</span><span class="n">sts</span><span class="o">.</span><span class="n">utctime_now</span><span class="p">())</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[20]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&#39;2021-03-15T14:19:49.322653+01&#39;
</pre></div></div>
</div>
</div>
<div class="section" id="Trim-time">
<h3>Trim time<a class="headerlink" href="#Trim-time" title="Permalink to this headline">¶</a></h3>
<p>Often when given an arbitrary time point we can trim it to move it back to a time point with some specific meaning like the beggining of the hour or week containing the time point. Take a look at the end of the calendar section to see the list of time constants available for trimming.</p>
<p>Trimming a time point is done using calendar semantics, so you can get different results by using different calendars.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[21]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># get the current time, then trim it to the start of the current hour</span>
<span class="n">now</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">utctime_now</span><span class="p">()</span>
<span class="n">now_hour</span> <span class="o">=</span> <span class="n">oslo</span><span class="o">.</span><span class="n">trim</span><span class="p">(</span><span class="n">now</span><span class="p">,</span> <span class="n">sts</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">HOUR</span><span class="p">)</span>

<span class="n">oslo</span><span class="o">.</span><span class="n">to_string</span><span class="p">(</span><span class="n">now_hour</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[21]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&#39;2021-03-15T14:00:00+01&#39;
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[22]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># get the current time, then trim it to the start of the current hour</span>
<span class="n">now</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">utctime_now</span><span class="p">()</span>
<span class="n">now_week</span> <span class="o">=</span> <span class="n">oslo</span><span class="o">.</span><span class="n">trim</span><span class="p">(</span><span class="n">now</span><span class="p">,</span> <span class="n">sts</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">WEEK</span><span class="p">)</span>

<span class="n">oslo</span><span class="o">.</span><span class="n">to_string</span><span class="p">(</span><span class="n">now_week</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[22]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&#39;2021-03-15T00:00:00+01&#39;
</pre></div></div>
</div>
</div>
<div class="section" id="Add-to-time">
<h3>Add to time<a class="headerlink" href="#Add-to-time" title="Permalink to this headline">¶</a></h3>
<p>If you want to add some offset to a time point that is not a specific length, like a month which could be 28, 29, 30, or 31 days, you should use the <code class="docutils literal notranslate"><span class="pre">add</span></code> function which handles these offsets easily.</p>
<p>The predefined offsets available for add is listed at the end of the calendar section.</p>
<p>The three next cells demonstrates the add function, first we retreive the current time and trim it to the start of the current month. The next two cells first add two months without calendar sematics and then with calendar semantics. Notice how you get diffenet results.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[23]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># get the current time, then trim it to the start of the current hour</span>
<span class="n">now</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">utctime_now</span><span class="p">()</span>
<span class="n">now_month</span> <span class="o">=</span> <span class="n">oslo</span><span class="o">.</span><span class="n">trim</span><span class="p">(</span><span class="n">now</span><span class="p">,</span> <span class="n">sts</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">MONTH</span><span class="p">)</span>

<span class="n">oslo</span><span class="o">.</span><span class="n">to_string</span><span class="p">(</span><span class="n">now_month</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[23]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&#39;2021-03-01T00:00:00+01&#39;
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[24]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># add two months without calendar semantics</span>
<span class="n">two_months</span> <span class="o">=</span> <span class="n">now_month</span> <span class="o">+</span> <span class="mi">2</span><span class="o">*</span><span class="n">sts</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">MONTH</span>

<span class="n">oslo</span><span class="o">.</span><span class="n">to_string</span><span class="p">(</span><span class="n">two_months</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[24]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&#39;2021-04-30T01:00:00+02&#39;
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[25]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># add two months with calendar semantics</span>
<span class="n">two_months</span> <span class="o">=</span> <span class="n">oslo</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">now_month</span><span class="p">,</span> <span class="n">sts</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">MONTH</span><span class="p">,</span> <span class="mi">2</span><span class="p">)</span>

<span class="n">oslo</span><span class="o">.</span><span class="n">to_string</span><span class="p">(</span><span class="n">two_months</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[25]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&#39;2021-05-01T00:00:00+02&#39;
</pre></div></div>
</div>
</div>
<div class="section" id="Diff-moments">
<h3>Diff moments<a class="headerlink" href="#Diff-moments" title="Permalink to this headline">¶</a></h3>
<p>Using a calendar we can also get the number of times we can subdivide a timespan. Some timespans work with calendar semantics, like a month, or a year which can be off differing length. The predefined time spans that have calendar semantics is listed at the end of the calendar section.</p>
<p>When using the <code class="docutils literal notranslate"><span class="pre">diff_units</span></code> function we specify first the start and end time points, then the delta to subdivide with.</p>
<p>The function does not return any remainder, and only return the whole number of times the delta subdivied the period. You need check for a remainder manually if required.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[26]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># define start, end, and delta</span>
<span class="n">t0</span> <span class="o">=</span> <span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2018</span><span class="p">,</span> <span class="mi">5</span><span class="p">,</span> <span class="mi">5</span><span class="p">)</span>
<span class="n">tN</span> <span class="o">=</span> <span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2018</span><span class="p">,</span> <span class="mi">9</span><span class="p">,</span> <span class="mi">17</span><span class="p">)</span>
<span class="n">dt</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">WEEK</span>

<span class="c1"># get the number of times dt subdivides [t0, tN&gt;</span>
<span class="n">n_weeks</span> <span class="o">=</span> <span class="n">utc</span><span class="o">.</span><span class="n">diff_units</span><span class="p">(</span><span class="n">t0</span><span class="p">,</span> <span class="n">tN</span><span class="p">,</span> <span class="n">dt</span><span class="p">)</span>
<span class="n">n_weeks</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[26]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
19
</pre></div></div>
</div>
<p>Notice that the timespan we choose did not subdivide fully into weeks. If we add the number of weeks to the start point we do not get fully to the end point:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[27]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># add the computed number of weeks to the start point</span>
<span class="n">utc</span><span class="o">.</span><span class="n">to_string</span><span class="p">(</span><span class="n">t0</span> <span class="o">+</span> <span class="n">n_weeks</span><span class="o">*</span><span class="n">dt</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[27]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&#39;2018-09-15T00:00:00Z&#39;
</pre></div></div>
</div>
</div>
<div class="section" id="Time-constants">
<h3>Time constants<a class="headerlink" href="#Time-constants" title="Permalink to this headline">¶</a></h3>
<p>The predefined time constants in SHyFT is listed below. These are the ones for wich calendar semantics work.</p>
<ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">Calendar.SECOND</span></code>: One second</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Calendar.MINUTE</span></code>: One minute, 60 seconds</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Calendar.HOUR</span></code>: One hour, 3600 seconds</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Calendar.WEEK</span></code>: Defines a semantic week</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Calendar.DAY</span></code>: Defines a semantic day</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Calendar.QUARTER</span></code>: Defines a semantic quarter, 3 months</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Calendar.MONTH</span></code>: Defines a semantic month</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Calendar.YEAR</span></code>: Defines a semantic year</p></li>
</ul>
</div>
</div>
<hr class="docutils" />
<div class="section" id="Time-periods">
<h2>Time periods<a class="headerlink" href="#Time-periods" title="Permalink to this headline">¶</a></h2>
<p>SHyFT has a time period construct to represent a pair of time points representing a timespan. The type exposed through the SHyFT Python API is the <code class="docutils literal notranslate"><span class="pre">UtcPeriod</span></code> construct.</p>
<p>The time period is represented as a half-open interval: The start value is included in the interval, while the end value is not included.</p>
<p>The two values of the period are <code class="docutils literal notranslate"><span class="pre">time</span></code> values, and thus represented as UTC+0.</p>
<div class="section" id="Initialization">
<h3>Initialization<a class="headerlink" href="#Initialization" title="Permalink to this headline">¶</a></h3>
<p>A <code class="docutils literal notranslate"><span class="pre">UtcPeriod</span></code> is initialized from two <code class="docutils literal notranslate"><span class="pre">time</span></code> values or two numbers representing time:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[28]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">sts</span><span class="o">.</span><span class="n">UtcPeriod</span><span class="p">(</span><span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2018</span><span class="p">),</span> <span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2019</span><span class="p">))</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[28]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
[2018-01-01T00:00:00Z,2019-01-01T00:00:00Z&gt;
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[29]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">sts</span><span class="o">.</span><span class="n">UtcPeriod</span><span class="p">(</span><span class="mi">1514764800</span><span class="p">,</span> <span class="mi">1546300800</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[29]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
[2018-01-01T00:00:00Z,2019-01-01T00:00:00Z&gt;
</pre></div></div>
</div>
</div>
<div class="section" id="List-of-functions">
<h3>List of functions<a class="headerlink" href="#List-of-functions" title="Permalink to this headline">¶</a></h3>
<p><code class="docutils literal notranslate"><span class="pre">UtcPeriod</span></code> has several built-in functions and properties. * start * end * timespan * valid * to_string * trim * intersection * overlaps * contains * diff_units</p>
</div>
<div class="section" id="Start-&amp;-end">
<h3>Start &amp; end<a class="headerlink" href="#Start-&-end" title="Permalink to this headline">¶</a></h3>
<p><code class="docutils literal notranslate"><span class="pre">start</span></code> and <code class="docutils literal notranslate"><span class="pre">end</span></code> are properites which simply returns the start and end time points of the period.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[30]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">period</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">UtcPeriod</span><span class="p">(</span><span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2018</span><span class="p">),</span> <span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2019</span><span class="p">))</span>
<span class="n">period</span><span class="o">.</span><span class="n">start</span><span class="p">,</span> <span class="n">period</span><span class="o">.</span><span class="n">end</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[30]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
(time(1514764800), time(1546300800))
</pre></div></div>
</div>
</div>
<div class="section" id="Timespan">
<h3>Timespan<a class="headerlink" href="#Timespan" title="Permalink to this headline">¶</a></h3>
<p><code class="docutils literal notranslate"><span class="pre">timespan</span></code> returns the <span class="math notranslate nohighlight">\(\Delta t\)</span> in seconds</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[31]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">period</span><span class="o">.</span><span class="n">timespan</span><span class="p">()</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[31]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
time(31536000)
</pre></div></div>
</div>
</div>
<div class="section" id="Valid">
<h3>Valid<a class="headerlink" href="#Valid" title="Permalink to this headline">¶</a></h3>
<p><code class="docutils literal notranslate"><span class="pre">valid</span></code> returns a boolean if the period is valid or not.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[32]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">period</span><span class="o">.</span><span class="n">valid</span><span class="p">()</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[32]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
True
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[33]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">invalid_period</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">UtcPeriod</span><span class="p">(</span><span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2019</span><span class="p">),</span> <span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2018</span><span class="p">))</span>
<span class="n">invalid_period</span><span class="o">.</span><span class="n">valid</span><span class="p">()</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[33]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
False
</pre></div></div>
</div>
</div>
<div class="section" id="To-string">
<h3>To string<a class="headerlink" href="#To-string" title="Permalink to this headline">¶</a></h3>
<p><code class="docutils literal notranslate"><span class="pre">to_string</span></code> returns the period start and end in ISO8601 format with the half-open interval symbols as a string.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[34]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">period</span><span class="o">.</span><span class="n">to_string</span><span class="p">()</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[34]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&#39;[2018-01-01T00:00:00Z,2019-01-01T00:00:00Z&gt;&#39;
</pre></div></div>
</div>
</div>
<div class="section" id="Trimming-periods">
<h3>Trimming periods<a class="headerlink" href="#Trimming-periods" title="Permalink to this headline">¶</a></h3>
<p>As with time values, time periods can also be trimmed to multiples of specific time deltas. When you have a <code class="docutils literal notranslate"><span class="pre">UtcPeriod</span></code> object you call the <code class="docutils literal notranslate"><span class="pre">trim</span></code> function on it to do this.</p>
<p>The time deltas are the same ones listed at the end of the calendar section.</p>
<p>When trimming time periods we have two modes to choose between. We can trim outwards to a multiple of the delta, or inwards to a multiple of the delta. This is specified as the third argument to the function. If it is left unspecified the function defaults to trimming inwards.</p>
<p>The first argument to the function is the calendar to use when trimming, the second argument is the delta to trim to, and the optional third argument is the trim policy.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[35]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">period</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">UtcPeriod</span><span class="p">(</span><span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2017</span><span class="p">,</span> <span class="mi">6</span><span class="p">),</span> <span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2019</span><span class="p">,</span> <span class="mi">6</span><span class="p">))</span>

<span class="n">period</span><span class="o">.</span><span class="n">trim</span><span class="p">(</span><span class="n">utc</span><span class="p">,</span> <span class="n">sts</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">YEAR</span><span class="p">,</span> <span class="n">sts</span><span class="o">.</span><span class="n">trim_policy</span><span class="o">.</span><span class="n">TRIM_IN</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[35]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
[2018-01-01T00:00:00Z,2019-01-01T00:00:00Z&gt;
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[36]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">period</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">UtcPeriod</span><span class="p">(</span><span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2017</span><span class="p">,</span> <span class="mi">6</span><span class="p">),</span> <span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2019</span><span class="p">,</span> <span class="mi">6</span><span class="p">))</span>

<span class="n">period</span><span class="o">.</span><span class="n">trim</span><span class="p">(</span><span class="n">utc</span><span class="p">,</span> <span class="n">sts</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">YEAR</span><span class="p">,</span> <span class="n">sts</span><span class="o">.</span><span class="n">trim_policy</span><span class="o">.</span><span class="n">TRIM_OUT</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[36]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
[2017-01-01T00:00:00Z,2020-01-01T00:00:00Z&gt;
</pre></div></div>
</div>
</div>
<div class="section" id="Intersection-&amp;-overlap">
<h3>Intersection &amp; overlap<a class="headerlink" href="#Intersection-&-overlap" title="Permalink to this headline">¶</a></h3>
<p>The time period construct have the functions to determine overlap between periods, and compute the intersection between two periods.</p>
<p>To demonstrate we define three periods, one for the first three month of the year, one for the middle three, and one for the last three:</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[37]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">period_1</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">UtcPeriod</span><span class="p">(</span><span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2018</span><span class="p">,</span> <span class="mi">1</span><span class="p">),</span> <span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2018</span><span class="p">,</span> <span class="mi">7</span><span class="p">))</span>
<span class="n">period_2</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">UtcPeriod</span><span class="p">(</span><span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2018</span><span class="p">,</span> <span class="mi">4</span><span class="p">),</span> <span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2018</span><span class="p">,</span> <span class="mi">10</span><span class="p">))</span>
<span class="n">period_3</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">UtcPeriod</span><span class="p">(</span><span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2018</span><span class="p">,</span> <span class="mi">7</span><span class="p">),</span> <span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2019</span><span class="p">,</span> <span class="mi">1</span><span class="p">))</span>
</pre></div>
</div>
</div>
<p>To determine if they overlap we can call the <code class="docutils literal notranslate"><span class="pre">overlaps</span></code> function on one of the periods, and pass the other as argument:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[38]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">period_1</span><span class="o">.</span><span class="n">overlaps</span><span class="p">(</span><span class="n">period_2</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[38]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
True
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[39]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">period_1</span><span class="o">.</span><span class="n">overlaps</span><span class="p">(</span><span class="n">period_3</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[39]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
False
</pre></div></div>
</div>
<p>The intersection is not implemented as a function in the <code class="docutils literal notranslate"><span class="pre">UtcPeriod</span></code> structure, it is a free function. This is why we had to implement it separatly.</p>
<p>To compute the intersection we pass the <code class="docutils literal notranslate"><span class="pre">intersection</span></code> function both the periods to compute intersection for. We get a special period out if the periods does not overlap.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[40]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">sts</span><span class="o">.</span><span class="n">intersection</span><span class="p">(</span><span class="n">period_1</span><span class="p">,</span> <span class="n">period_2</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[40]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
[2018-04-01T00:00:00Z,2018-07-01T00:00:00Z&gt;
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[41]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">sts</span><span class="o">.</span><span class="n">intersection</span><span class="p">(</span><span class="n">period_1</span><span class="p">,</span> <span class="n">period_3</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[41]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
[not-valid-period&gt;
</pre></div></div>
</div>
</div>
<div class="section" id="Moment-in-period">
<h3>Moment in period<a class="headerlink" href="#Moment-in-period" title="Permalink to this headline">¶</a></h3>
<p>To check if a time point is inside a period we can call the <code class="docutils literal notranslate"><span class="pre">contains</span></code> function on the period with the time point as argument.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[42]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">period</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">UtcPeriod</span><span class="p">(</span><span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2018</span><span class="p">),</span> <span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2019</span><span class="p">))</span>
</pre></div>
</div>
</div>
<p>The <code class="docutils literal notranslate"><span class="pre">contains</span></code> function accepts the time point, and returns a boolean signifying whether the point is within the period or not:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[43]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">moment</span> <span class="o">=</span> <span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2017</span><span class="p">,</span> <span class="mi">6</span><span class="p">)</span>

<span class="n">period</span><span class="o">.</span><span class="n">contains</span><span class="p">(</span><span class="n">moment</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[43]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
False
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[44]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">moment</span> <span class="o">=</span> <span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2018</span><span class="p">,</span> <span class="mi">6</span><span class="p">)</span>

<span class="n">period</span><span class="o">.</span><span class="n">contains</span><span class="p">(</span><span class="n">moment</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[44]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
True
</pre></div></div>
</div>
</div>
<div class="section" id="Diff-a-period">
<h3>Diff a period<a class="headerlink" href="#Diff-a-period" title="Permalink to this headline">¶</a></h3>
<p>To determine how many times a period can be subdivided by a delta, we do not need to unpack the points defining the period and use <code class="docutils literal notranslate"><span class="pre">Calendar.diff_units</span></code>. The <code class="docutils literal notranslate"><span class="pre">UtcPeriod</span></code> construct have a <code class="docutils literal notranslate"><span class="pre">diff_units</span></code> function accepting a calendar and the delta. Otherwise this function works just like the <code class="docutils literal notranslate"><span class="pre">Calendar.diff_units</span></code>.</p>
<p>To demonstrate we define a period of some length:</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[45]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># define a period</span>
<span class="n">period</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">UtcPeriod</span><span class="p">(</span><span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2018</span><span class="p">,</span> <span class="mi">3</span><span class="p">,</span> <span class="mi">15</span><span class="p">,</span> <span class="mi">17</span><span class="p">),</span> <span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2018</span><span class="p">,</span> <span class="mi">10</span><span class="p">,</span> <span class="mi">2</span><span class="p">,</span> <span class="mi">4</span><span class="p">))</span>
</pre></div>
</div>
</div>
<p>By using <code class="docutils literal notranslate"><span class="pre">UtcPeriod.diff_units</span></code> on the period with <code class="docutils literal notranslate"><span class="pre">Calendar.DAY</span></code> as the delta, we get the number of whole days in the period:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[46]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># determine the number of whole days the period can be subdivided into</span>
<span class="n">period</span><span class="o">.</span><span class="n">diff_units</span><span class="p">(</span><span class="n">utc</span><span class="p">,</span> <span class="n">sts</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">DAY</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[46]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
200
</pre></div></div>
</div>
<p>Or we can determine the number of minutes the period can be subdivided into:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[47]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># determine the number of whole minutes the period can be subdivided into</span>
<span class="n">period</span><span class="o">.</span><span class="n">diff_units</span><span class="p">(</span><span class="n">utc</span><span class="p">,</span> <span class="n">sts</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">MINUTE</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[47]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
288660
</pre></div></div>
</div>
</div>
</div>
</div>


           </div>
           
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2021, The Shyft project

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>